# std::reverse_iterator::base

From cppreference.com
< cpp‎ | iterator‎ | reverse iterator

Iterator base() const; |  | (until C++17)
constexpr Iterator base() const; |  | (since C++17)

Returns the underlying base iterator. That is std::reverse_iterator(it).base() == it.

The base iterator refers to the element that is next (from the std::reverse_iterator::iterator_type perspective) to the element the `reverse_iterator` is currently pointing to. That is &*(rit.base() - 1) == &*rit.

### Parameters

(none)

### Return value

The underlying iterator.

### Exceptions

(none)

### Example

Run this code

    #include <iostream>
    #include <iterator>
    #include <vector>

    int main()
    {
        std::vector<int> v = { 0, 1, 2, 3, 4, 5 };

        using RevIt = std::reverse_iterator<std::vector<int>::iterator>;
        RevIt r_end(v.begin());
        RevIt r_begin(v.end());

        for (auto it = r_end.base(); it != r_begin.base(); ++it) {
            std::cout << *it << " ";
        }
        std::cout << "\n";
    }

Output:

    0 1 2 3 4 5

### See also

operator*operator-> | accesses the pointed-to element (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/iterator/reverse_iterator/base&oldid=83609"